'********************** ALPHA RELEASE ***************************************
'*                                                                          *
'* BLKMAKE.BAS: - Sprite drawing program. outines for use ONLY in screen 13 *
'*              - use only in combination with the MGPLIB library           *
'*                (Marcel Games Programming LIBrary; made in pure assembly) *
'*              - NOT for COMMERCIAL use, unless I get credit AND cash !    *
'*                Non-commercial stuff: do what you like, as long as you    *
'*                give me credit and/or the source code.                    *
'*              - Distribute this code only complete and unchanged !        *
'*              - Programmed in QuickBasic 4.5 .                            *
'*              - This stuff is hot!                                        *
'*                                                                          *
'*                                                                          *
'*  Alpha release                    Marcel Smolenaars, August 1997         *
'*                                   email: smolenaa@sci.kun.nl             *
'*                                   http://www.geocities.com/Park/9751     *
'****************************************************************************

'  bugs: - rotating boxes that do not have the same height as width
'          results in junk
'        - some options are not implemented in the whole program
'          which results in some graphical "errors"  for example:
'          in the options menu "show outlines only" isn't really implemented
'          yet
'        - sometimes the text is not drawn correctly : junk is the result
'          this is due to the reallocation in memory of the array which stores
'          the font data. this happens even though i've put '$static above
'          the array to make it a static array. qb bug ?
'          this bug will mostly occur when working in the environment
'
'  if you find any other bugs, please report them to me !!
'             (isn't that the purpose of alpha releases?)

'$INCLUDE: 'mgplib.BI'
DECLARE SUB Save2 ()
DECLARE SUB DrawAll ()
DECLARE SUB ClearScreen (kl%)
DECLARE SUB Test ()
DECLARE SUB Save ()
DECLARE SUB Load ()
DECLARE SUB CheckInput ()
DECLARE SUB SetCol (kol%, rij%, kl%, DrawIt%)
DECLARE SUB DrawWorkScreen ()
DECLARE SUB LoadPal (file$)
DECLARE SUB ChangeSize ()
DECLARE SUB ScrollSpr (dx%, dy%)
DECLARE SUB Rotate (dir AS INTEGER)
DECLARE SUB DrawCurSprite ()
DECLARE FUNCTION GetCol% (spr%, xb%, yb%)
DECLARE SUB SelectSprite (n AS INTEGER)
DECLARE SUB ExchangeColors (c1%, c2%)
DECLARE SUB Edit.SelectBox ()
DECLARE SUB Edit.Paste ()
DECLARE SUB Quit ()
DECLARE SUB SelectLine (x1%, y1%, SortOfLine%)
DECLARE SUB WaitForFreeButton ()
DECLARE SUB DrawGrid ()
DECLARE SUB Mirror.Horizontal ()
DECLARE SUB Mirror.Vertical ()
DECLARE SUB Info ()
DECLARE SUB WaitForPressedButton ()
DECLARE SUB SavePal ()
DECLARE SUB EditPalette (c%)
DECLARE SUB Shove.Draw (sh AS ANY)
DECLARE FUNCTION Shove.Check% (sh AS ANY)
DECLARE FUNCTION CurExePath$ ()
DECLARE SUB Stretch ()
DECLARE SUB SaveOptions ()
DECLARE SUB GetDataDir ()
DECLARE SUB LoadData ()

'subs and functions from TEXT13.BAS
DECLARE FUNCTION KBflags& ()
DECLARE FUNCTION Choise% (x%, y%, PickList$)
DECLARE SUB DrawButton (x%, y%, B%, h%, Status%)
DECLARE SUB TextButton (x%, y%, t$, Status%)
DECLARE SUB WriteText (zin$, xPos%, yPos%, kl%)
DECLARE FUNCTION KeyPressed% ()
DECLARE FUNCTION SelectRange% (x%, y%, pixDx%, min%, max%, StartValue%)

CONST FALSE = 0, TRUE = -1
CONST xMax = 256, yMax = 189  'maximal coordinats drawing part of screen
CONST MaxLoadBlk = 20, MaxIcons = 13
CONST MaxBlkWidth = 64, MaxBlkHeigth = 64
CONST IconButSize = 14
CONST SwapFile = "BLKMAKE.XXX"
CONST ConfigFile = "BLKMAKE.CFG"

CONST BasicPUT = 1  'VERY IMPORTANT  if it's 8 then everything will be
                    'saved in the format PUT format for screen 13 used by
                    'basic, if 1 then saving will be done in PutSprite /
                    'PsetSprite format  (change only in 1 or 8 !)

'Scancodes of most used keys
CONST Down = 80, Up = 72, PgDwn = 81, PgUp = 73, Home = 71, EndLn = 79
CONST Left = 75, Right = 77, Enter = 28, Esc = 1, Sp = 57, Tb = 15, Ctrl = 29
CONST Alt = 56, LeftShift = 42, RightShift = 54, Ins = 82, Del = 83
CONST BackSpace = 14, F1 = 59, F2 = 60, F3 = 61, F4 = 62, F5 = 63, F6 = 64
CONST F7 = 65, F8 = 66, F9 = 67, F10 = 68, F11 = 87, F12 = 88

'type for use by Shift.Hori.Draw, Shift.Vert.Draw, Shift.Hori.Check and
'Shift.Vert.Check, which draw and check horizontal and/or vertical shoves
'used for selecting a value
TYPE ShoveBarType
  sort AS INTEGER    ' if 0 then horizontal else vertical shove
  x AS INTEGER
  y AS INTEGER
  size AS INTEGER
  value AS INTEGER
  min AS INTEGER
  max AS INTEGER
  Col AS INTEGER
END TYPE

ON ERROR GOTO ErrHandler

'$STATIC
DIM SHARED FontData(0 TO 1500) AS INTEGER
DIM SHARED BBx AS INTEGER ' width of 1 'pixel' of a block on the screen
DIM SHARED BBy AS INTEGER ' height of 1 'pixel' of a block on the screen
DIM SHARED BlkHeigth AS INTEGER    'aantal pixels in hoogte
DIM SHARED BlkWidth AS INTEGER   'aantal pixels in breedte
DIM SHARED CurrentCol AS INTEGER
DIM SHARED TotalBlocksLoaded%
DIM SHARED CurSprEdited AS INTEGER
DIM SHARED BlocksEdited%
DIM SHARED LoadedFile$
DIM SHARED PaletFile AS STRING
DIM SHARED SprLoaded AS INTEGER
DIM SHARED CurTool AS INTEGER: CurTool = 1
DIM SHARED EditX1 AS INTEGER, EditY1 AS INTEGER, EditX2 AS INTEGER, EditY2 AS INTEGER
DIM SHARED EditActive AS INTEGER, ClipBoardUsed AS INTEGER
DIM SHARED ExePath$
DIM SHARED Grid AS INTEGER 'if 1 : (draw a grid) elseif 0 : (don't draw a grid)
DIM SHARED UseSolids AS INTEGER '1 OR 0
DIM SHARED ShowBlkPos AS INTEGER '1 OR 0
'$DYNAMIC
DIM SHARED EditArray(0 TO 4097) AS INTEGER
DIM SHARED IconPics(0 TO 65, 1 TO MaxIcons) AS INTEGER
DIM SHARED Sprites(0 TO 4097, 1 TO MaxLoadBlk) AS INTEGER

TotalBlocksLoaded% = 0
CurSprEdited = 1
CurrentCol = 1
BlkWidth = 12
BlkHeigth = 12
Sprites(0, CurSprEdited) = BlkWidth
Sprites(1, CurSprEdited) = BlkHeigth
BBx = 6
BBy = 6


'DIM handle AS INTEGER, dummy AS INTEGER
'DEFINT A-Z
'DIM char AS STRING * 1
'OPEN "scr13_3.fnt" FOR BINARY AS 1
'OPEN "c:\qb45\scr13_3.fnt" FOR BINARY AS 2
'  dy = 6
'  char = CHR$(6): PUT 2, , char
'  char = CHR$(dy): PUT 2, , char
'  a$ = SPACE$(dy)
'  FOR n = 0 TO 255
'     GET 1, 1 + n * 8, a$
'     PUT 2, , a$
'  NEXT
'CLOSE
'END

SCREEN 13
LoadData
DrawAll
MouseInit
MouseShow

DO

 CheckInput

LOOP


ErrHandler:
    CLS
    SCREEN 0: WIDTH 80
    PRINT "Error "; ERR; " occurred : ";
    PRINT
    SELECT CASE ERR
        CASE 7: PRINT "out of memory"
    END SELECT
    END

' "You're ugly !"  - One twin to an other
' Always keep your utility belt well stocked.
' Very funny, Scotty. Now beam up my clothes!

REM $STATIC
DEFINT A-Z
SUB ChangeSize
  CONST xSpr = 75, ySpr = 45
  DIM w AS ShoveBarType, h AS ShoveBarType

  'set the values for the vertical and horizontal shove bar
  w.sort = 0: h.sort = 1
  w.size = MaxBlkWidth: h.size = MaxBlkHeigth
  w.value = BlkWidth: h.value = BlkHeigth
  w.x = xSpr - 1: h.x = xSpr + MaxBlkWidth + 3
  w.y = ySpr + MaxBlkHeigth + 3: h.y = ySpr - 1
  w.Col = 1: h.Col = 1
  w.min = 1: h.min = 1
  w.max = MaxBlkWidth: h.max = MaxBlkHeigth
  w.value = BlkWidth: h.value = BlkHeigth

  WaitForFreeButton
  mousehide
  DrawButton 70, 30, 129, 124, 0
  DrawButton 71, 31, 127, 9, 1
  WriteText "SET SPRITE SIZE", 90, 33, 0
  DrawButton xSpr - 1, ySpr - 1, MaxBlkWidth + 1, MaxBlkHeigth + 1, 1
  PsetSprite xSpr, ySpr, Sprites(0, CurSprEdited)
  WriteText "HEIGHT:", 146, 60, 0
  WriteText "WIDTH:", 150, 85, 0
  WriteText LTRIM$(STR$(BlkHeigth)), 160, 68, 0
  WriteText LTRIM$(STR$(BlkWidth)), 160, 93, 0
 
  'Shove.Draw w
  'Shove.Draw h
  TextButton 86, 137, "  OK  ", 0
  TextButton 140, 137, "CANCEL", 0
  MouseShow
 
  ht = BlkHeigth: wd = BlkWidth
 
  DO
 
   'IF Shove.Check%(w) OR Shove.Check%(h) THEN
   'END IF
 
   MouseStatus x, y, But
   IF But = 1 THEN
    IF y >= ySpr AND y < ySpr + MaxBlkHeigth AND x >= xSpr AND x < xSpr + MaxBlkWidth THEN
     IF y - ySpr + 1 <> ht OR x - xSpr + 1 <> wd THEN
        mousehide
        WriteText LTRIM$(STR$(ht)), 160, 68, 7
        WriteText LTRIM$(STR$(wd)), 160, 93, 7
        ht = y - ySpr + 1: wd = x - xSpr + 1
        WriteText LTRIM$(STR$(ht)), 160, 68, 0
        WriteText LTRIM$(STR$(wd)), 160, 93, 0
        FillBar xSpr, ySpr, wd, ht, 0
        PsetSprite xSpr, ySpr, Sprites(0, CurSprEdited)
        'FillBar xSpr + wd, ySpr, MaxBlkWidth - wd, MaxBlkHeigth, 7
        IF wd < MaxBlkWidth THEN LINE (xSpr + wd, ySpr)-(xSpr + MaxBlkWidth - 1, ySpr + MaxBlkHeigth - 1), 7, BF
        IF ht < MaxBlkHeigth THEN LINE (xSpr, ySpr + ht)-(xSpr + MaxBlkWidth - 1, ySpr + MaxBlkHeigth - 1), 7, BF
        MouseShow
     END IF
    END IF
    IF y < 146 AND y > 137 THEN
      IF x < 128 AND x > 86 THEN      'OK button pressed
         GetSprite xSpr, ySpr, xSpr + wd - 1, ySpr + ht - 1, Sprites(0, CurSprEdited)
         SelectSprite CurSprEdited
         TextButton 86, 137, "  OK  ", 1
         WaitForFreeButton
         EXIT DO
      ELSEIF x > 140 AND x < 182 THEN 'Cancel button pressed
         TextButton 140, 137, "CANCEL", 1
         WaitForFreeButton
         EXIT DO
      END IF
    END IF
   END IF
  LOOP


END SUB

DEFSNG A-Z
SUB CheckInput
STATIC OldBlkX%, OldBlkY%

DIM n%, Col AS INTEGER, row AS INTEGER
DIM x%, y%, But%, xb%, yb%, I%, j%, k%, l%


a$ = INKEY$
IF a$ = "" THEN a$ = CHR$(1)

MouseStatus x%, y%, But%
'LOCATE 1, 20: PRINT x%; y%

SELECT CASE Scancode%
  CASE Down: IF KBflags& AND 3 THEN CALL ScrollSpr(0, 1)
  CASE Up:   IF KBflags& AND 3 THEN CALL ScrollSpr(0, -1)
  CASE Left: IF KBflags& AND 3 THEN CALL ScrollSpr(-1, 0)
  CASE Right: IF KBflags& AND 3 THEN CALL ScrollSpr(1, 0)
END SELECT

IF x% < BlkWidth * BBx AND y% < BlkHeigth * BBy THEN
   SELECT CASE Scancode%
     CASE Down:  IF y% + BBy < BlkHeigth * BBy THEN y% = y% + BBy: FOR n% = 1 TO 7: RetraceWait: NEXT: CALL MouseMove(x%, y%)
     CASE Up:    IF y% - BBy >= 0 THEN y% = y% - BBy: FOR n% = 1 TO 7: RetraceWait: NEXT: CALL MouseMove(x%, y%)
     CASE Left:  IF x% - BBx >= 0 THEN x% = x% - BBx: FOR n% = 1 TO 7: RetraceWait: NEXT: CALL MouseMove(x%, y%)
     CASE Right: IF x% + BBx < BlkWidth * BBx THEN x% = x% + BBx: FOR n% = 1 TO 7: RetraceWait: NEXT: CALL MouseMove(x%, y%)
   END SELECT
  
   xb% = x% \ BBx: yb% = y% \ BBy
   IF xb% <> OldBlkX% OR yb% <> OldBlkY% THEN    'draw white outline of point
      mousehide                                  'of sprite mouse points at
      IF Grid THEN
        LINE (OldBlkX% * BBx, OldBlkY% * BBy)-STEP(BBx, BBy), 8, B
        LINE (xb% * BBx, yb% * BBy)-STEP(BBx, BBy), 15, B
      ELSE
        LINE (OldBlkX% * BBx, OldBlkY% * BBy)-STEP(BBx - 1, BBy - 1), GetCol%(CurSprEdited, OldBlkX%, OldBlkY%), B
        LINE (xb% * BBx, yb% * BBy)-STEP(BBx - 1, BBy - 1), 15, B
      END IF
      IF ShowBlkPos THEN
        WriteText LTRIM$(STR$(OldBlkX%)), 200, 192, 7
        WriteText LTRIM$(STR$(OldBlkY%)), 217, 192, 7
        WriteText LTRIM$(STR$(xb%)), 200, 192, 0
        WriteText LTRIM$(STR$(yb%)), 217, 192, 0
      END IF
      MouseShow
   END IF
   OldBlkX% = xb%: OldBlkY% = yb%
   IF (But% = 1 OR a$ = " ") THEN  'fill block clicked on with current color
        SELECT CASE CurTool
            CASE 1:  SetCol xb%, yb%, CurrentCol, TRUE
            CASE 2 TO 4: SelectLine xb%, yb%, CurTool
            CASE 5: Edit.SelectBox
        END SELECT

   ELSEIF (But% = 2 OR ASC(a$) = 13) THEN    'Change select color by "reading"
        FillBar 279 + 5 * (CurrentCol \ 32), 1 + 4 * (CurrentCol MOD 32), 5, 4, CurrentCol
        CurrentCol = GetCol%(CurSprEdited, xb%, yb%)
        LINE (281 + 5 * (CurrentCol \ 32), 2 + 4 * (CurrentCol MOD 32))-STEP(0, 2), 15
        LINE (280 + 5 * (CurrentCol \ 32), 3 + 4 * (CurrentCol MOD 32))-STEP(2, 0), 15
        FillBar 282, 136, 17, 13, CurrentCol
        FillBar 302, 138, 17, 9, 7
        WriteText LTRIM$(STR$(CurrentCol)), 302, 138, 0
   END IF
END IF


IF But% = 1 THEN
  'Pressed on of the tool selection buttons ?
  IF x% >= 258 AND x% <= 277 AND y% <= 189 THEN
     n% = (y% \ IconButSize) + 1
     SELECT CASE n%
       CASE 1 TO 5
            IF n% <> CurTool THEN
                mousehide
                DrawButton 258, (CurTool - 1) * IconButSize, 19, IconButSize - 1, 0
                PutSprite 260, (CurTool - 1) * IconButSize + 3, IconPics(0, CurTool)
                IF CurTool = 5 THEN EditActive = 0: EditX1 = 0: EditY1 = 0: EditX2 = 0: EditY1 = 0
                CurTool = n%
                DrawButton 258, (CurTool - 1) * IconButSize, 19, IconButSize - 1, 1
                PutSprite 260, (CurTool - 1) * IconButSize + 3, IconPics(0, CurTool)
                MouseShow
                WaitForFreeButton
            END IF
      
       CASE 6 TO 13:
               mousehide
               DrawButton 258, (n% - 1) * IconButSize, 19, IconButSize - 1, 1
               PutSprite 260, (n% - 1) * IconButSize + 3, IconPics(0, n%)
               IF n% < 8 OR n% > 11 THEN
                WaitForFreeButton
               ELSE FOR n = 1 TO 5: RetraceWait: NEXT
               END IF
               SELECT CASE n%
                 CASE 6: Rotate 1
                 CASE 7: Rotate -1
                 CASE 8: ScrollSpr 0, -1
                 CASE 9: ScrollSpr 1, 0
                 CASE 10: ScrollSpr -1, 0
                 CASE 11: ScrollSpr 0, 1
                 CASE 12: Mirror.Horizontal
                 CASE 13: Mirror.Vertical
               END SELECT
               DrawButton 258, (n% - 1) * IconButSize, 19, IconButSize - 1, 0
               PutSprite 260, (n% - 1) * IconButSize + 3, IconPics(0, n%)
               MouseShow
               DrawCurSprite
               IF n% > 8 AND n% < 12 THEN FOR n = 1 TO 10: RetraceWait: NEXT
               
       CASE ELSE
     END SELECT
 
  'Other color selected on color panel ?
  ELSEIF x% >= 279 AND x% <= 318 AND y% >= 1 AND y% <= 129 THEN
    IF CurrentCol <> 32 * ((x% - 279) \ 5) + (y% - 1) \ 4 THEN
        mousehide
        FillBar 279 + 5 * (CurrentCol \ 32), 1 + 4 * (CurrentCol MOD 32), 5, 4, CurrentCol
        CurrentCol = 32 * ((x% - 279) \ 5) + (y% - 1) \ 4
        LINE (281 + 5 * (CurrentCol \ 32), 2 + 4 * (CurrentCol MOD 32))-STEP(0, 2), 15
        LINE (280 + 5 * (CurrentCol \ 32), 3 + 4 * (CurrentCol MOD 32))-STEP(2, 0), 15
        FillBar 282, 136, 17, 13, CurrentCol
        FillBar 302, 138, 17, 9, 7
        WriteText LTRIM$(STR$(CurrentCol)), 302, 138, 0
        MouseShow
    END IF

  ELSEIF x% >= 279 AND x% <= 318 AND y% >= 155 AND y% <= 166 THEN
    mousehide
    DrawButton 278, 154, 41, 13, 1: WriteText "PALET", 283, 159, 0
    MouseShow
    EditPalette CurrentCol
    DrawAll
  ELSEIF x% >= 279 AND x% <= 318 AND y% >= 169 AND y% <= 180 THEN
    mousehide
    DrawButton 278, 168, 41, 13, 1: WriteText "INFO", 287, 173, 0
    MouseShow
    Info
    DrawAll
  END IF

END IF

IF But% = 2 THEN
  IF x% >= 279 AND x% <= 318 AND y% >= 1 AND y% <= 129 THEN
       n% = 32 * ((x% - 279) \ 5) + (y% - 1) \ 4
       EditPalette n%
       DrawAll
  END IF
END IF


IF SprLoaded THEN
  IF But% = 1 AND x% >= 276 AND x% <= 288 AND y% >= 190 THEN
    mousehide
    TextButton 275, 190, "<", 1
    WaitForFreeButton
    a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 7
    FillBar 0, 0, BBx * BlkWidth + 1, BBy * BlkHeigth + 1, 0
    IF CurSprEdited > 1 THEN
        SelectSprite CurSprEdited - 1
    ELSE
        SelectSprite TotalBlocksLoaded%
    END IF
    TextButton 275, 190, "<", 0
    a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 0
    MouseShow
    DrawCurSprite
    OldBlkX% = 0: OldBlkY% = 0
  END IF
  IF But% = 1 AND x% >= 308 AND x% <= 319 AND y% >= 190 THEN
    mousehide
    TextButton 307, 190, ">", 1
    WaitForFreeButton
    a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 7
    FillBar 0, 0, BBx * BlkWidth + 1, BBy * BlkHeigth + 1, 0
    IF CurSprEdited < TotalBlocksLoaded% THEN
        SelectSprite CurSprEdited + 1
    ELSE
        SelectSprite 1
    END IF
    TextButton 307, 190, ">", 0
    a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 0
    MouseShow
    DrawCurSprite
    OldBlkX% = 0: OldBlkY% = 0
  END IF
END IF


IF But% = 1 AND x% <= 30 AND y% > 190 THEN
      TextButton 0, 190, "FILE", 1
      n% = Choise%(10, 153, "NEW`LOAD`SAVE`EXIT")
      SELECT CASE n%
            CASE 0: DrawAll
            CASE 1: 'unload loaded file
                    TotalBlocksLoaded% = 1
                    CurSprEdited = 1
                    Sprites(0, CurSprEdited) = BlkWidth
                    Sprites(1, CurSprEdited) = BlkHeigth
                    SprLoaded = FALSE
                    ClearScreen 0
                    DrawAll
            CASE 2: 'load sprite-file
                    Load
                    OldBlkX% = 0: OldBlkY% = 0
                    DrawAll
            CASE 3: 'save sprites
                    IF SprLoaded THEN Save2 ELSE Save
                    DrawAll
            CASE 4: Quit
     
      END SELECT
      
END IF

IF (But% = 1 OR a$ = " ") AND y% > 190 THEN
 IF x% >= 31 AND x% < 61 THEN
   TextButton 31, 190, "DRAW", 1
   n% = Choise%(40, 129, "FILL SPRITE`ROTATE SPRITE`SET SPRITE SIZE`STRETCH SPRITE`TEST SPRITE`LOAD PALETTE`SAVE PALETTE")
   SELECT CASE n%
        CASE 0: DrawAll
        CASE 1: ' FILL sprite with current color
                ClearScreen CurrentCol
                DrawAll
        CASE 2: n% = Choise%(135, 137, "ROTATE LEFT`ROTATE RIGHT ")
                SELECT CASE n%
                  CASE 1: Rotate -1   'rotate 90 degrees clock-wize
                  CASE 2: Rotate 1  'rotate 90 degrees counter-clock-wize
                END SELECT
                DrawAll
        CASE 3: DrawAll
                ChangeSize
                DrawAll
        CASE 4: 'stretch sprite
                Stretch
                DrawAll
        CASE 5: 'test sprite
                WaitForFreeButton
                Test
                DrawAll
        CASE 6: 'load palet
                LoadPal ""
                DrawAll
        CASE 7: SavePal
        END SELECT
  
 ELSEIF x% > 61 AND x% < 98 THEN
   TextButton 62, 190, "TOOLS", 1
   n% = Choise%(71, 145, "PENCIL`LINE`EMPTY BOX`FILLED BOX`SELECT AREA")
   IF n% > 0 THEN CurTool = n%
   DrawAll
  
 ELSEIF x% > 99 AND x% < 128 THEN
   IF EditActive THEN
      TextButton 99, 190, "EDIT", 1
      n% = Choise%(109, 153, "PASTE`COPY`DELETE`CLEAR CLIPBOARD")
      SELECT CASE n%
        CASE 1: Edit.Paste
        CASE 2:
                IF EditActive THEN
                    PsetSprite 0, 0, Sprites(0, EditActive)
                    GetSprite EditX1, EditY1, EditX2, EditY2, EditArray(0)
                    ClipBoardUsed = TRUE
                ELSE
                    SOUND 750, .2
                END IF
        CASE 4: ClipBoardUsed = FALSE
                EditActive = 0: EditX1 = 0: EditY1 = 0
                EditX2 = 0: EditY1 = 0
      END SELECT
      DrawAll
   ELSE
      SOUND 750, .2
      WaitForFreeButton
   END IF

 ELSEIF x% > 130 AND x% < 178 THEN
  
   TextButton 130, 190, "OPTIONS", 1
   WaitForFreeButton
   IF Grid THEN a$ = "HIDE GRID" ELSE a$ = "SHOW GRID"
   IF UseSolids = 0 THEN a$ = a$ + "`SHOW SOLIDS" ELSE a$ = a$ + "`SHOW OUTLINES ONLY"
   IF ShowBlkPos THEN a$ = a$ + "`HIDE MOUSE LOCATION" ELSE a$ = a$ + "`SHOW MOUSE LOCATION"
   a$ = a$ + "`SAVE OPTIONS"
   n% = Choise%(140, 153, a$)
   SELECT CASE n%
     CASE 1: Grid = Grid XOR 1
     CASE 2: UseSolids = UseSolids XOR 1
     CASE 3: ShowBlkPos = ShowBlkPos XOR 1
     CASE 4: SaveOptions
   END SELECT
   DrawAll
 END IF
END IF


SELECT CASE LCASE$(a$)
    CASE "c": CALL ClearScreen(CurrentCol)  ' FILL
              DrawCurSprite
    CASE "t": 'test sprite
               Test
    CASE "i":  'information currently edited sprite
               mousehide
               DrawButton 278, 168, 41, 13, 1: WriteText "INFO", 287, 173, 0
               MouseShow
               Info
               DrawAll
   
    CASE "l": 'load sprite-file
               Load
               OldBlkX% = 0: OldBlkY% = 0
    CASE "s": 'save sprites
                IF SprLoaded THEN Save2 ELSE Save
    CASE "<", ",":  'previous loaded file
                mousehide
                FillBar 0, 0, BBx * BlkWidth + 1, BBy * BlkHeigth + 1, 0
                a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 7
                IF SprLoaded THEN
                  IF CurSprEdited > 1 THEN
                    SelectSprite CurSprEdited - 1
                    DrawAll
                  ELSE
                    SelectSprite TotalBlocksLoaded%
                    DrawAll
                  END IF
                END IF
                a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 0
                OldBlkX% = 0: OldBlkY% = 0
                MouseShow

    CASE ">", ".":  'next loaded file
                mousehide
                FillBar 0, 0, BBx * BlkWidth + 1, BBy * BlkHeigth + 1, 0
                a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 7
                IF SprLoaded THEN
                  n% = 1 + (CurSprEdited MOD TotalBlocksLoaded%)
                  SelectSprite n%
                  DrawAll
                END IF
                a$ = LTRIM$(STR$(CurSprEdited)): WriteText a$, 304 - 6 * LEN(a$), 192, 0
                OldBlkX% = 0: OldBlkY% = 0
                MouseShow

    CASE "n":  'unload loaded file
                TotalBlocksLoaded% = 1
                CurSprEdited = 1
                Sprites(0, CurSprEdited) = BlkWidth
                Sprites(1, CurSprEdited) = BlkHeigth
                ClearScreen 0
                SprLoaded = FALSE
                DrawAll
               
    CASE "q":   Quit
   
    CASE "x":
                mousehide
                CLS
                PRINT "Change a color into another": PRINT
                INPUT "Color number to change:", x%
                INPUT "Change it into color:", y%
                ExchangeColors x%, y%
                MouseShow
                DrawAll
  
   CASE "p":    'load palet
                LoadPal ""

END SELECT
EXIT SUB

END SUB

SUB ClearScreen (c%)
DIM x AS INTEGER, y AS INTEGER

FOR x = 0 TO BlkWidth - 1
FOR y = 0 TO BlkHeigth - 1
    SetCol x, y, c%, FALSE
NEXT: NEXT

END SUB

DEFINT A-Z
FUNCTION CurExePath$
'Returns path currently executing program is in.

DIM Regs AS RegType, offset AS LONG, BeginOffset AS LONG

'Get PSP address

   Regs.ax = &H6200
   CALL INTERRUPT(&H21, Regs, Regs)
   PSPSegment = Regs.bx

'Find environment address from PSP

   DEF SEG = PSPSegment
   EnvSegment = PEEK(&H2D) * 256 + PEEK(&H2C)

'Find the filename

   DEF SEG = EnvSegment
   EOT = FALSE                 'Set end of environment table flag
   offset = 0

   WHILE NOT EOT
     Byte = PEEK(offset)       'Get table character
     IF Byte = 0 THEN          'End of environment string?
        'PRINT                   'Uncomment to print environment
        offset = offset + 1
        Byte = PEEK(offset)
        IF Byte = 0 THEN        'End of environment?
          offset = offset + 3   'Yes - Skip over nulls & tbl info
          BeginOffset = offset - 1
          c% = PEEK(offset)
          WHILE c% <> 0                   'Assemble filename string
            FileN$ = FileN$ + CHR$(c%)    '  from individual
            offset = offset + 1           '  characters
            c% = PEEK(offset)
            IF c% = 92 THEN LenOfPath = offset - BeginOffset
          WEND
          EOT = TRUE              'Set flag to exit while/wend loop
        END IF
     ELSE                        'No-Read more environment string
        'PRINT CHR$(Byte);         'Uncomment to print environment
        offset = offset + 1
     END IF
   WEND
   DEF SEG

   'FileN$ now contains the full name exe name, like : path\exe_name
 
   'Extracting only the path is possible because the place where the last
   'backslash was found has been stored in LenOfPath
   IF LenOfPath > 0 THEN
    CurExePath$ = MID$(FileN$, 1, LenOfPath)
   ELSE
    CurExePath$ = FileN$
   END IF

END FUNCTION

DEFSNG A-Z
SUB DrawAll

mousehide
FillMem &HA000, 0, &HFA00, 0      '= cls
MouseShow
DrawWorkScreen
DrawCurSprite

END SUB

SUB DrawCurSprite
  DIM SprOfs&, m AS INTEGER, n AS INTEGER, x%, y%, xp%, yp%
 
  mousehide
 
  IF Grid THEN
    DrawGrid
    m = BBx - 1: n = BBy - 1
  ELSE
    LINE (-1, -1)-(BBx * BlkWidth, BBy * BlkHeigth), 7, B
    m = BBx + 0: n = BBy + 0
  END IF
 
  IF EditActive = CurSprEdited THEN LINE (EditX1 * BBx, EditY1 * BBy)-((EditX2 + 1) * BBx, (EditY2 + 1) * BBy), 15, B, &HAAAA
 
  DEF SEG = VARSEG(Sprites(0, CurSprEdited))
    yp% = Grid
    SprOfs& = VARPTR(Sprites(2, CurSprEdited))
    FOR y% = 0 TO BlkHeigth - 1
    xp% = Grid
    FOR x% = 0 TO BlkWidth - 1
        FillBar xp%, yp%, m, n, PEEK(SprOfs&)
        xp% = xp% + BBx
        SprOfs& = SprOfs& + 1
    NEXT
    yp% = yp% + BBy
    NEXT
  DEF SEG

  MouseShow

END SUB

SUB DrawGrid
  DIM SprOfs&, n%, x%, y%, xp%, yp%
 
  mousehide
    y% = BBy * BlkHeigth
    FOR n% = 0 TO BlkWidth
        LINE (x%, 0)-STEP(0, y%), 8    ', , 21845
        x% = x% + BBx
    NEXT
    x% = BBx * BlkWidth
    FOR n% = 0 TO BlkHeigth
        LINE (0, yp%)-STEP(x%, 0), 8     ', , &HAAAA
        yp% = yp% + BBy
    NEXT
  MouseShow
 
END SUB

SUB DrawWorkScreen
DIM m%, n%, a$

mousehide

SetFont13 6, 6, FontData(1)    'Re-initialize the font; because the memory
                               'allocation is dynamic the adress of FontData
                               'can change

'DrawButton 278, 0, 41, 129, 0

LINE (278, 0)-STEP(41, 129), 7, B
FOR n% = 0 TO 255
 FillBar 279 + 5 * (n% \ 32), 1 + 4 * (n% MOD 32), 5, 4, n%
NEXT n%

LINE (281 + 5 * (CurrentCol \ 32), 2 + 4 * (CurrentCol MOD 32))-STEP(0, 2), 15
LINE (280 + 5 * (CurrentCol \ 32), 3 + 4 * (CurrentCol MOD 32))-STEP(2, 0), 15

DrawButton 278, 130, 41, 23, 0
DrawButton 281, 135, 18, 14, 1
FillBar 282, 136, 17, 13, CurrentCol
WriteText LTRIM$(STR$(CurrentCol)), 302, 138, 0
DrawButton 278, 154, 41, 13, 0: WriteText "PALET", 283, 158, 0
DrawButton 278, 168, 41, 13, 0: WriteText "INFO", 287, 172, 0
'WriteText "TOOL", 288, 163, 8
'PutSprite 286, 172, IconPics(0, CurTool)

DrawButton 0, 190, 319, 9, 0
TextButton 0, 190, "FILE", 0
TextButton 31, 190, "DRAW", 0
TextButton 62, 190, "TOOLS", 0
TextButton 99, 190, "EDIT", 0
TextButton 130, 190, "OPTIONS", 0
'WriteText LTRIM$(STR$(TotalBlocksLoaded%)) + " BLOCKS LOADED", 70, 191, 0

FOR n% = 0 TO MaxIcons - 1
    'DrawButton (130 + n% * 18), 190, 17, 9, 0
    'PutSprite (131 + n% * 18), 191, IconPics(0, n% + 1)
    'LINE (258, n% * 16)-STEP(19, 16), 8, BF
    'LINE (258, n% * 16)-STEP(19, 16), 7, B
    IF n% + 1 = CurTool THEN m% = 1 ELSE m% = 0
    DrawButton 258, n% * IconButSize, 19, IconButSize - 1, m%
    PutSprite 260, n% * IconButSize + 3, IconPics(0, n% + 1)
NEXT

IF ShowBlkPos THEN WriteText ":", 212, 192, 0

IF SprLoaded THEN
  'WriteText "ACTIVE BLOCK", 195, 192, 0
  TextButton 275, 190, "<", 0
  DrawButton 288, 190, 18, 9, 0
  a$ = LTRIM$(STR$(CurSprEdited))
  WriteText a$, 304 - 6 * LEN(a$), 192, 0
  TextButton 307, 190, ">", 0
END IF

MouseShow

END SUB

SUB Edit.Paste
DIM temp(0 TO 4097) AS INTEGER
DIM xt AS INTEGER, yt AS INTEGER, But AS INTEGER
DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

 MouseStatus x1, y1, But
 x1 = x1 \ BBx: y1 = y1 \ BBy
  
 mousehide
 PsetSprite 0, 0, Sprites(0, CurSprEdited)
 GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, temp(0)
 PsetSprite x1, y1, EditArray(0)
 GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
 MouseShow
 DrawCurSprite


 DO
   
    MouseStatus xt, yt, But
    xt = xt \ BBx
    yt = yt \ BBy
    IF xt > BlkWidth - 1 THEN xt = BlkWidth - 1
    IF yt > BlkHeigth - 1 THEN yt = BlkHeigth - 1
    IF xt <> x1 OR yt <> y1 THEN
       x1 = xt: y1 = yt
       mousehide
       PsetSprite 0, 0, temp(0)
       PsetSprite x1, y1, EditArray(0)
       GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
       MouseShow
       IF x1 + EditArray(0) > BlkWidth - 1 THEN x2 = BlkWidth - 1 ELSE x2 = x1 + EditArray(0) - 1
       IF y1 + EditArray(1) > BlkHeigth - 1 THEN y2 = BlkHeigth - 1 ELSE y2 = y1 + EditArray(1) - 1
       DrawCurSprite
       mousehide
       LINE (x1 * BBx, y1 * BBy)-((x2 + 1) * BBx, (y2 + 1) * BBy), 15, B, &HAAAA
       MouseShow
    END IF

 LOOP UNTIL But <> 0 OR Scancode% = Esc

 IF (But AND 2) OR Scancode% = Esc THEN   ' Don't paste it !
    mousehide
    PsetSprite 0, 0, temp(0)
    GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
    MouseShow
 END IF

END SUB

SUB Edit.SelectBox
' Selects a rectangle of the sprite to copy or delete.
DIM xt AS INTEGER, yt AS INTEGER, But AS INTEGER, n AS INTEGER
DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

 MouseStatus xt, yt, But
 x1 = xt \ BBx: y1 = yt \ BBy           'get starting coordinates for box

 DO
   
    MouseStatus xt, yt, But
    xt = xt \ BBx
    yt = yt \ BBy
    IF xt > BlkWidth - 1 THEN xt = BlkWidth - 1
    IF yt > BlkHeigth - 1 THEN yt = BlkHeigth - 1
    IF x2 <> xt OR y2 <> yt THEN
        mousehide
        IF Grid THEN
            LINE (x1 * BBx, y1 * BBy)-((x2 + 1) * BBx, (y2 + 1) * BBy), 8, B
         ELSE
            FOR n = x1 TO x2
              FillBar (n * BBx + Grid), y1 * BBy + Grid, BBx + 1, BBy + 1, GetCol%(CurSprEdited, n, y1)
              FillBar (n * BBx + Grid), y2 * BBy + Grid, BBx + 1, BBy + 1, GetCol%(CurSprEdited, n, y2)
            NEXT
            FOR n = y1 + 1 TO y2 - 1
              FillBar (x1 * BBx + Grid), n * BBy + Grid, BBx + 1, BBy + 1, GetCol%(CurSprEdited, x1, n)
              FillBar (x2 * BBx + Grid), n * BBy + Grid, BBx + 1, BBy + 1, GetCol%(CurSprEdited, x2, n)
            NEXT
        END IF
        x2 = xt
        y2 = yt
        IF x2 < x1 THEN SWAP x1, x2
        IF y2 < y1 THEN SWAP y1, y2
        LINE (x1 * BBx, y1 * BBy)-((x2 + 1) * BBx, (y2 + 1) * BBy), 15, B
        MouseShow
    END IF

 LOOP UNTIL But <> 1

 IF But <> 0 THEN   'right mouse button pressed: box selection canceled
    EditActive = 0
    SOUND 750, .2
 ELSE               'right mouse button NOT pressed: box selection ok
    IF x2 < x1 THEN SWAP x1, x2
    IF y2 < y1 THEN SWAP y1, y2
    EditX1 = x1: EditY1 = y1: EditX2 = x2: EditY2 = y2
    EditActive = CurSprEdited
 END IF

 DrawCurSprite
 WaitForFreeButton

END SUB

DEFINT A-Z
SUB EditPalette (c)
  DIM rSh AS ShoveBarType, gSh AS ShoveBarType, bSh AS ShoveBarType
 
  'set some common values for the 3 vertical shove bars
  rSh.sort = 1: rSh.min = 0: rSh.max = 63: rSh.y = 59: rSh.size = 64
  rSh.Col = c
  gSh = rSh: bSh = rSh
  rSh.x = 95: gSh.x = 127: bSh.x = 159

  GetPal c, R, G, B
  rSh.value = R: gSh.value = G: bSh.value = B

  WaitForFreeButton
  mousehide
  DrawButton 70, 30, 120, 120, 0
  DrawButton 71, 31, 118, 10, 1
  WriteText "PALETTE COLOR" + STR$(c), 80, 33, 0
  TextButton 86, 45, "RED GREEN BLUE", 1
  Shove.Draw rSh
  Shove.Draw gSh
  Shove.Draw bSh
  TextButton 86, 137, "  OK  ", 0
  TextButton 140, 137, "CANCEL", 0
  MouseShow

  DO
  
   IF Shove.Check%(rSh) OR Shove.Check%(gSh) OR Shove.Check%(bSh) THEN
      SetPal c, rSh.value, gSh.value, bSh.value
   END IF
  
   MouseStatus x, y, But
   IF But = 1 THEN
    IF y < 146 AND y > 137 THEN
      IF x < 128 AND x > 86 THEN      'OK button pressed
         TextButton 86, 137, "  OK  ", 1
         WaitForFreeButton
         EXIT DO
      ELSEIF x > 140 AND x < 182 THEN 'Cancel button pressed
         TextButton 140, 137, "CANCEL", 1
         WaitForFreeButton
         SetPal c, R, G, B
         EXIT DO
      END IF
    END IF
   END IF
  LOOP

END SUB

DEFSNG A-Z
SUB ExchangeColors (c1%, c2%)
  DIM SprOfs&, n AS INTEGER

  DEF SEG = VARSEG(Sprites(0, CurSprEdited))
    SprOfs& = VARPTR(Sprites(2, CurSprEdited))
    FOR n = 1 TO BlkWidth * BlkHeigth
        IF PEEK(SprOfs&) = c1% THEN POKE SprOfs&, c2%
        SprOfs& = SprOfs& + 1
    NEXT
  DEF SEG

END SUB

FUNCTION GetCol% (spr%, xb%, yb%)
  DIM SprOfs&

  DEF SEG = VARSEG(Sprites(0, spr%))
    SprOfs& = VARPTR(Sprites(2, spr%)) + Sprites(0, spr%) * yb% + xb%
    GetCol% = PEEK(SprOfs&)
  DEF SEG

END FUNCTION

DEFINT A-Z
SUB Info

DoInfoAgain:
 
  WaitForFreeButton
 
  mousehide
  DrawButton 70, 30, 120, 120, 0
  DrawButton 71, 31, 118, 10, 1
  WriteText "SPRITE INFORMATION", 78, 34, 0
  DrawButton 75, 45, BlkWidth + 1, BlkHeigth + 1, 1
  PsetSprite 76, 46, Sprites(0, CurSprEdited)
  LINE (75, 50 + BlkHeigth)-STEP(BlkWidth + 1, 0), 8
  LINE (75, 50 + BlkHeigth)-STEP(2, 2), 8
  LINE (75, 50 + BlkHeigth)-STEP(2, -2), 8
  LINE (76 + BlkWidth, 50 + BlkHeigth)-STEP(-2, 2), 8
  LINE (76 + BlkWidth, 50 + BlkHeigth)-STEP(-2, -2), 8
  a$ = LTRIM$(STR$(BlkWidth))
  WriteText a$, 76 + (BlkWidth \ 2) - (LEN(a$) * 3), 53 + BlkHeigth, 0
  LINE (80 + BlkWidth, 45)-STEP(0, BlkHeigth + 1), 8
  LINE (80 + BlkWidth, 45)-STEP(2, 2), 8
  LINE (80 + BlkWidth, 45)-STEP(-2, 2), 8
  LINE (80 + BlkWidth, 46 + BlkHeigth)-STEP(2, -2), 8
  LINE (80 + BlkWidth, 46 + BlkHeigth)-STEP(-2, -2), 8
  a$ = LTRIM$(STR$(BlkHeigth))
  WriteText a$, 83 + BlkWidth, 42 + BlkHeigth \ 2, 0
  WriteText "MEM SIZE:" + LTRIM$(STR$(BlkHeigth * BlkWidth + 4)) + " BYTES", 76, 125, 8
  TextButton 95, 137, "CHANGE SIZE", 0
  MouseShow
 
  DO
    MouseStatus x, y, But
    IF But = 1 THEN
     IF x > 95 AND y > 137 AND x < 167 AND y < 151 THEN
       mousehide
       TextButton 95, 137, "CHANGE SIZE", 1
       MouseShow
       WaitForFreeButton
       ChangeSize
       DrawAll
       GOTO DoInfoAgain
      ELSE
       EXIT DO
     END IF
    END IF
  LOOP

  WaitForFreeButton

END SUB

DEFSNG A-Z
SUB Load
DIM n AS INTEGER, char AS STRING * 1, c AS INTEGER, k AS INTEGER

mousehide
SCREEN 0: WIDTH 80, 25

SHELL "dir *.spr /b"
PRINT "Which sprite-file do you wish to load [.SPR] ?"
PRINT
INPUT " ", file$
file$ = LTRIM$(RTRIM$(file$))
PRINT

IF file$ <> "" THEN
 
  IF INSTR(file$, ".") = 0 THEN file$ = file$ + ".SPR"
 
  OPEN file$ FOR BINARY AS 1

  IF LOF(1) = 0 THEN
    PRINT "This file does not exist."
    PRINT "Former sprite(s) still in memory restored."
    CLOSE #1
    KILL file$
  ELSE
   
    LoadedFile$ = UCASE$(file$)
    PRINT "Loading... sprite number :";
    n = 0
    'PRINT LOF(1)
    DO
     
      n = n + 1
      LOCATE , 27: PRINT n;
     
      GET 1, , Sprites(0, n)    'Get width of a sprite
      GET 1, , Sprites(1, n)    'Get heigth of a sprite
      Sprites(0, n) = Sprites(0, n) \ BasicPUT
      k = Sprites(0, n) * Sprites(1, n)
      FOR c = 1 TO (k \ 2)
        GET 1, , Sprites(c + 1, n)
      NEXT
      IF k AND 1 THEN
        GET 1, , char
        Sprites(k \ 2 + 3, n) = ASC(char)
      END IF

    LOOP UNTIL SEEK(1) >= LOF(1)
   
    CLOSE 1
    TotalBlocksLoaded% = n
    SelectSprite 1
    SprLoaded = TRUE
    
  END IF

END IF

PRINT
PRINT "Press any key to continue.."
SLEEP

SCREEN 13
LoadPal PaletFile
DrawAll
MouseInit
MouseShow

END SUB

SUB LoadData
DIM n AS INTEGER, a$
   
  'ExePath$ = CurExePath$
  ExePath$ = ""

  'IF n THEN ExePath$ = CurExePath$ ELSE ExePath$ = ""
  '  a$ = ExePath$ + "MAIN.PAL"
  '  OPEN a$ FOR BINARY AS 1
  '   IF LOF(1) = 0 THEN KILL a$: GOTO DataNotFound
  '  CLOSE 1
  '  a$ = ExePath$ + "SCR13_3.BSV"
  '  OPEN a$ FOR BINARY AS 1
  '   IF LOF(1) = 0 THEN KILL a$: GOTO DataNotFound
  '  CLOSE 1
  '  a$ = ExePath$ + "ICONS.BSV"
  '  OPEN a$ FOR BINARY AS 1
  '   IF LOF(1) = 0 THEN KILL a$: GOTO DataNotFound
  '  CLOSE 1
 
DataFound:
    DEF SEG = VARSEG(FontData(0)): BLOAD ExePath$ + "scr13_3.bsv", VARPTR(FontData(0))
    SetFont13 6, 6, FontData(1)    'Initialize the font
    DEF SEG = VARSEG(IconPics(0, 1)): BLOAD ExePath$ + "icons.bsv", VARPTR(IconPics(0, 1))
    DEF SEG

    OPEN ExePath$ + ConfigFile FOR BINARY AS 1
        GET 1, , Grid
        GET 1, , UseSolids
        GET 1, , ShowBlkPos
    CLOSE 1
   
    PaletFile = ExePath$ + "MAIN.PAL"
    LoadPal PaletFile
    EXIT SUB


DataNotFound:
    SCREEN 0
    WIDTH 80, 25
    PRINT "Error : can't find all data files !"
    END

END SUB

SUB LoadPal (file$)

DIM Col AS INTEGER, R AS INTEGER, G AS INTEGER, B AS INTEGER
DIM char AS STRING * 1

mousehide

file$ = LTRIM$(RTRIM$(file$))

IF file$ = "" THEN
    mousehide
    CLS
    SHELL "dir *.pal /b"
    PRINT "Enter PAL-file you wish to load ";
    INPUT file$
    file$ = UCASE$(LTRIM$(RTRIM$(file$)))
    IF file$ <> "" THEN
        IF INSTR(file$, ".") = 0 THEN file$ = file$ + ".PAL"
    END IF
    MouseInit
    MouseShow
    DrawAll
END IF

IF file$ <> "" THEN

  OPEN file$ FOR BINARY AS 1

  IF LOF(1) = 0 THEN
 
     PRINT "This file does not exist."
     PRINT "Press any key to continue.."
     SLEEP
     CLOSE 1
     KILL file$

    ELSE
  
      FOR Col = 0 TO 255
        GET 1, , char: R = ASC(char)
        GET 1, , char: G = ASC(char)
        GET 1, , char: B = ASC(char)
        SetPal Col, R, G, B
      NEXT Col
      PaletFile = file$
      CLOSE 1
 
  END IF

END IF

'SetPal 7, 13, 43, 30

END SUB

SUB Mirror.Horizontal
  DIM x AS INTEGER, y AS INTEGER, destX AS INTEGER
  DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

  IF EditActive THEN
       x1 = EditX1: x2 = EditX2: y1 = EditY1: y2 = EditY2
  ELSE x1 = 0: x2 = BlkWidth - 1: y1 = 0: y2 = BlkHeigth - 1
  END IF

  mousehide
  PsetSprite 0, 0, Sprites(0, CurSprEdited)
  PsetSprite BlkWidth, 0, Sprites(0, CurSprEdited)
 
  FOR x = 0 TO x2 - x1   'BlkWidth - 1
   destX = BlkWidth + x2 - x    '(BlkWidth - 1 - x)
   FOR y = y1 TO y2
        Pset13 destX, y, Point13%(x1 + x, y)
  NEXT y, x
  GetSprite BlkWidth, 0, BlkWidth + BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
 
  MouseShow
 
END SUB

SUB Mirror.Vertical
  DIM x AS INTEGER, y AS INTEGER, destY AS INTEGER
  DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

  IF EditActive THEN
       x1 = EditX1: x2 = EditX2: y1 = EditY1: y2 = EditY2
  ELSE x1 = 0: x2 = BlkWidth - 1: y1 = 0: y2 = BlkHeigth - 1
  END IF

  mousehide
  PsetSprite 0, 0, Sprites(0, CurSprEdited)
  PsetSprite BlkWidth, 0, Sprites(0, CurSprEdited)
 
  FOR y = 0 TO y2 - y1
   destY = y2 - y
   FOR x = x1 TO x2
        Pset13 BlkWidth + x, destY, Point13%(x, y1 + y)
  NEXT x, y
  GetSprite BlkWidth, 0, BlkWidth + BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
  MouseShow

END SUB

SUB Quit
    SCREEN 0
    WIDTH 80, 25
    END
END SUB

DEFINT A-Z
SUB Rotate (dir AS INTEGER)
   
    IF EditActive THEN
      x1 = EditX1: x2 = EditX2: y1 = EditY1: y2 = EditY2
    ELSE x1 = 0: x2 = BlkWidth - 1: y1 = 0: y2 = BlkHeigth - 1
    END IF
   
    mousehide

    IF BlkHeigth > BlkWidth THEN n = BlkHeigth ELSE n = BlkWidth
    FillBar BlkWidth, 0, n, n, 0
    PsetSprite 0, 0, Sprites(0, CurSprEdited)
    PsetSprite BlkWidth, 0, Sprites(0, CurSprEdited)

    IF dir = -1 THEN    'rotate 90 degrees anti-clockwise = leftwards
        FOR y = 0 TO y2 - y1
         FOR x = 0 TO x2 - x1
            Pset13 BlkWidth + x1 + x, y1 + y, Point13%(x2 - y, y1 + x)
         NEXT x, y
    ELSEIF dir = 1 THEN 'rotate 90 degrees clockwise = to the right
        FOR y = 0 TO y2 - y1
         FOR x = 0 TO x2 - x1
            Pset13 BlkWidth + x1 + x, y1 + y, Point13%(x1 + y, y2 - x)
         NEXT x, y
    END IF

    GetSprite BlkWidth, 0, BlkWidth + BlkHeigth - 1, BlkWidth - 1, Sprites(0, CurSprEdited)
    MouseShow
   
END SUB

DEFSNG A-Z
SUB Save
DIM char AS STRING * 1
mousehide
SCREEN 0: WIDTH 80, 25

PRINT "In which file do you wish to save the sprite(s) ?  [.SPR]"
PRINT
INPUT " ", file$
file$ = UCASE$(LTRIM$(RTRIM$(file$)))
PRINT

IF file$ <> "" THEN

 IF INSTR(file$, ".") = 0 THEN file$ = file$ + ".SPR"

 OPEN file$ FOR BINARY AS #1

 IF LOF(1) = 0 THEN
   
    PRINT "This file does not exist yet."
    PRINT "Do you wish to create this file (y/n) ?"
    DO
      a$ = LCASE$(INPUT$(1))
      IF a$ = "y" OR a$ = "n" THEN EXIT DO ELSE BEEP
    LOOP
    IF a$ = "n" THEN
        CLOSE #1
        KILL file$
    ELSE
        SEEK #1, LOF(1) + 1
        rij% = BlkWidth * BasicPUT: PUT #1, , rij%
        rij% = BlkHeigth: PUT #1, , rij%
        FOR rij% = 0 TO BlkHeigth - 1
        FOR kol% = 0 TO BlkWidth - 1
            char = CHR$(GetCol%(CurSprEdited, kol%, rij%))
            PUT #1, , char
        NEXT kol%, rij%
        CLOSE #1
        PRINT
        PRINT "Sprite added to "; file$
    END IF

 ELSE
   
    PRINT
    PRINT "This file already exists !"
    LOCATE , , 1
    PRINT "Do you wish to overwrite "; file$; " (y/n) ?"
    DO: a$ = LCASE$(INPUT$(1))
     IF a$ = "y" OR a$ = "n" THEN EXIT DO ELSE BEEP
    LOOP
    IF a$ = "n" THEN
   
        PRINT "Do you wish to append your sprite to "; file$; " (y/n) ?"
        DO: a$ = LCASE$(INPUT$(1))
        IF a$ = "y" OR a$ = "n" THEN EXIT DO ELSE BEEP
        LOOP
        IF a$ = "n" THEN
            CLOSE #1
        ELSE
            SEEK #1, LOF(1) + 1
            rij% = BlkWidth * BasicPUT: PUT #1, , rij%
            rij% = BlkHeigth: PUT #1, , rij%
            FOR rij% = 0 TO BlkHeigth - 1
            FOR kol% = 0 TO BlkWidth - 1
                char = CHR$(GetCol%(CurSprEdited, kol%, rij%))
                PUT #1, , char
            NEXT kol%, rij%
            CLOSE #1
            PRINT
            PRINT "Sprite added to "; UCASE$(file$)
        END IF
   
    ELSE      'overwrite the already existing sprite file
        CLOSE 1
        KILL file$
        OPEN file$ FOR BINARY AS 1
           kol% = BlkWidth * BasicPUT
           PUT #1, , kol%
           PUT #1, , BlkHeigth
           FOR rij% = 0 TO BlkHeigth - 1
           FOR kol% = 0 TO BlkWidth - 1
               char = CHR$(GetCol%(CurSprEdited, kol%, rij%))
               PUT #1, , char
           NEXT kol%, rij%
           PRINT "Sprite written to "; UCASE$(file$)
        CLOSE 1
    END IF
 END IF
END IF


PRINT
PRINT "Press any key to continue.."
a$ = INPUT$(1)


SCREEN 13
DrawAll
LoadPal PaletFile
MouseInit
MouseShow

END SUB

SUB Save2
DIM k%, l%, m%, n%, x%, y%, ori$, cur$, char AS STRING * 1, ptr&

mousehide
CLS

OPEN LoadedFile$ FOR BINARY AS 1
OPEN SwapFile FOR BINARY AS 2
IF LOF(2) > 0 THEN
   CLOSE 2
   KILL SwapFile
   OPEN SwapFile FOR BINARY AS 2
END IF

FOR n% = 1 TO TotalBlocksLoaded%
  FillBar 35, 0, 320, MaxBlkHeigth, 0
  m% = FALSE
 
  GET 1, , k%: ori$ = MKI$(k%)
  GET 1, , l%: ori$ = ori$ + MKI$(l%)
  cur$ = SPACE$(k% * l%)
  GET 1, , cur$
  ori$ = ori$ + cur$
  PsetSpritePTR 1, 35, VARSEG(ori$), SADD(ori$) 'draw sprite in file on screen
  PsetSprite 160, 35, Sprites(0, n%)  'draw the sprite in memory on screen
  cur$ = SPACE$(Sprites(0, n%) * Sprites(1, n%) + 4)
  GetSpritePTR 160, 35, 159 + Sprites(0, n%), 34 + Sprites(1, n%), VARSEG(cur$), SADD(cur$)
  MID$(cur$, 1, 2) = MKI$(CVI(MID$(cur$, 1, 2)) * BasicPUT)

  IF ori$ <> cur$ THEN  'sprite was changed since loading of sprite file
    
    LINE (0, 34)-STEP(k% + 1, l% + 1), 15, B
    LINE (159, 34)-STEP(Sprites(0, n%) + 1, Sprites(1, n%) + 1), 15, B
   
    LOCATE 1, 1
    PRINT "Sprite"; n%; "was changed since last save."
    PRINT
    PRINT "Before :           After :"

    LOCATE 12, 1, 1
    PRINT "Replace the changed sprite (y/n) ?";
    DO: char = LCASE$(INPUT$(1)): LOOP UNTIL char = "y" OR char = "n"
    PRINT
    IF char = "n" THEN
     
       'PRINT "Append changed sprite to "; LoadedFile$; " (y/n) ?";
       'DO: B$ = LCASE$(INPUT$(1)): LOOP UNTIL B$ = "y" OR B$ = "n"
       PRINT
       IF B$ = "y" THEN   'blok achteraanplaatsen
         PRINT "Sprite "; n%; " appended to"; UCASE$(LoadedFile$); " ."
         PRINT : PRINT "Press any key to continue.."
         a$ = INPUT$(1)
     
       ELSE
         
           'PRINT "Append the changed sprite to other file (y/n) ?";
           'DO: c$ = LCASE$(INPUT$(1)): LOOP UNTIL c$ = "y" OR c$ = "n"
           IF c$ = "y" THEN
              INPUT "Enter the complete(!) file name :", file$
              OPEN file$ FOR BINARY AS 3
                SEEK 3, LOF(3) + 1
              CLOSE 3
              PRINT "New version of sprite"; n%; "has been added to "; UCASE$(file$); " ."
              PRINT : PRINT "Press any key to continue.."
              a$ = INPUT$(1)
          
           ELSE   'do not save changes to sprite
            
             PUT 2, , ori$  'write the sprite in file to the swapfile
             PRINT : PRINT "Changes to sprite not saved."
             PRINT : PRINT "Press any key to continue.."
             char = INPUT$(1)
          
           END IF
     
       END IF

    ELSE 'replace sprite in sprite-file
     
         PUT 2, , cur$      'write the sprite in memory to the swapfile
        
         PRINT "Sprite"; n%; "has been replaced."
         PRINT : PRINT "Press any key to continue.."
         a$ = INPUT$(1)
  
    END IF
    CLS

  ELSE   'Sprite has not changed: save it anyway to swapfile
   
    PUT 2, , cur$      'write the sprite in memory to the swapfile

  END IF


NEXT n%

CLOSE
SHELL "copy " + SwapFile + " " + LoadedFile$
KILL SwapFile

LOCATE , , 0
MouseShow
DrawAll
EXIT SUB

END SUB

SUB SaveOptions
 OPEN ExePath$ + ConfigFile FOR BINARY AS 1
  PUT 1, , Grid
  PUT 1, , UseSolids
  PUT 1, , ShowBlkPos
 CLOSE 1
END SUB

SUB SavePal

DIM Col AS INTEGER, R AS INTEGER, G AS INTEGER, B AS INTEGER
DIM char AS STRING * 1

   
    'FOR col = 0 TO 255
    '  GetPal col, r, g, b
    '  pchar(col * 3 + 1) = CHR$(r)
    '  pchar(col * 3 + 2) = CHR$(g)
    '  pchar(col * 3 + 3) = CHR$(b)
    'NEXT
   
    mousehide
    CLS
    SHELL "dir *.pal /b"
    PRINT "Save the palette to ";
    LOCATE , , 1: INPUT file$: LOCATE , , 0
    file$ = UCASE$(LTRIM$(RTRIM$(file$)))
    IF file$ = "" THEN
        DrawAll
        MouseShow
        EXIT SUB
    END IF
    Col = INSTR(file$, ".")
    IF Col = 0 THEN file$ = file$ + ".PAL"
  
   OPEN file$ FOR BINARY AS #1

   IF LOF(1) <> 0 THEN

     PRINT file$; " already exists !"
     PRINT "Do you wish to overwrite it ?";
     DO: char = UCASE$(INPUT$(1))
     LOOP UNTIL char = "Y" OR char = "N"
     LOCATE , , 0
     PRINT char
     IF char = "Y" THEN
        CLOSE #1
        KILL file$
        OPEN file$ FOR BINARY AS #1
        GOSUB SaveThePalette
     ELSE
        CLOSE #1
     END IF

   ELSE
      GOSUB SaveThePalette
   END IF


PaletFile = file$
DrawAll
MouseShow
EXIT SUB


SaveThePalette:
      FOR Col = 0 TO 255
        GetPal Col, R, G, B
        char = CHR$(R): PUT 1, , char
        char = CHR$(G): PUT 1, , char
        char = CHR$(B): PUT 1, , char
      NEXT
      CLOSE 1
      RETURN

END SUB

SUB ScrollSpr (dx%, dy%)
 DIM n AS INTEGER, x AS INTEGER, y AS INTEGER
 DIM x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER

 IF EditActive THEN
      x1 = EditX1: x2 = EditX2: y1 = EditY1: y2 = EditY2
 ELSE x1 = 0: x2 = BlkWidth - 1: y1 = 0: y2 = BlkHeigth - 1
 END IF

 PsetSprite 0, 0, Sprites(0, CurSprEdited)
 PsetSprite BlkWidth, 0, Sprites(0, CurSprEdited)

 IF dy% = 1 THEN
   FOR x = x1 TO x2
   FOR y = y1 TO y2 - 1
      Pset13 BlkWidth + x, y + 1, Point13%(x, y)
   NEXT
   NEXT
   FOR x = x1 TO x2
      Pset13 BlkWidth + x, y1, Point13%(x, y2)
   NEXT
 ELSEIF dy% = -1 THEN
   FOR x = x1 TO x2
   FOR y = y1 + 1 TO y2
      Pset13 BlkWidth + x, y - 1, Point13%(x, y)
   NEXT
   NEXT
   FOR x = x1 TO x2
      Pset13 BlkWidth + x, y2, Point13%(x, y1)
   NEXT
 END IF

 IF dx% = 1 THEN
   FOR x = x1 TO x2 - 1
   FOR y = y1 TO y2
      Pset13 BlkWidth + 1 + x, y, Point13%(x, y)
   NEXT
   NEXT
   FOR y = y1 TO y2
      Pset13 BlkWidth + x1, y, Point13%(x2, y)
   NEXT
 ELSEIF dx% = -1 THEN
   FOR x = x1 + 1 TO x2
   FOR y = y1 TO y2
      Pset13 BlkWidth - 1 + x, y, Point13%(x, y)
   NEXT
   NEXT
   FOR y = y1 TO y2
      Pset13 BlkWidth + x2, y, Point13%(x1, y)
   NEXT
 END IF

 GetSprite BlkWidth, 0, BlkWidth + BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
 DrawCurSprite


END SUB

'   *********** OLD STUFF THAT MIGHT BE USEFUL *****************
SUB SelectEmptyBox (x1 AS INTEGER, y1 AS INTEGER)
'DIM xt AS INTEGER, yt AS INTEGER, but AS INTEGER, n AS INTEGER
'DIM x2 AS INTEGER, y2 AS INTEGER
'
' 'MouseStatus xt, yt, but
' 'x2 = xt \ BBx: y2 = yt \ BBy           'get starting coordinates for box
'
' DO
'
'    MouseStatus xt, yt, but
'    xt = xt \ BBx
'    yt = yt \ BBy
'    IF xt > BlkWidth - 1 THEN xt = BlkWidth - 1
'    IF yt > BlkHeigth - 1 THEN yt = BlkHeigth - 1
'    IF x2 <> xt OR y2 <> yt THEN
'        x2 = xt
'        y2 = yt
'        'LOCATE 1, 20: PRINT x1; y1; x2; y2
'        DrawCurSprite
'        mousehide
'        IF x2 < x1 THEN n = -1 ELSE n = 1
'        FOR xt = x1 TO x2 STEP n
'            LINE (xt * BBx + 1, y1 * BBy + 1)-STEP(BBx - 2, BBy - 2), CurrentCol, BF
'            LINE (xt * BBx + 1, y2 * BBy + 1)-STEP(BBx - 2, BBy - 2), CurrentCol, BF
'        NEXT
'        IF y2 < y1 THEN n = -1 ELSE n = 1
'        FOR yt = y1 TO y2 STEP n
'            LINE (x1 * BBx + 1, yt * BBy + 1)-STEP(BBx - 2, BBy - 2), CurrentCol, BF
'            LINE (x2 * BBx + 1, yt * BBy + 1)-STEP(BBx - 2, BBy - 2), CurrentCol, BF
'        NEXT
'        MouseShow
'    END IF
'
' LOOP UNTIL but <> 1
' 'right mouse button NOT pressed: box selection NOT canceled
' IF but = 0 THEN
'    IF x2 < x1 THEN n = -1 ELSE n = 1
'    FOR xt = x1 TO x2 STEP n
'        SetCol xt, y1, CurrentCol, FALSE
'        SetCol xt, y2, CurrentCol, FALSE
'    NEXT
'    IF y2 < y1 THEN n = -1 ELSE n = 1
'    FOR yt = y1 TO y2 STEP n
'        SetCol x1, yt, CurrentCol, FALSE
'        SetCol x2, yt, CurrentCol, FALSE
'    NEXT
' ELSE
'    SOUND 750, .2
' END IF
'
' DrawCurSprite
' WaitForFreeButton
'
END SUB

'   *********** OLD STUFF THAT MIGHT BE USEFUL *****************
SUB SelectFilledBox (x1 AS INTEGER, y1 AS INTEGER)
'DIM xt AS INTEGER, yt AS INTEGER, but AS INTEGER
'DIM x2 AS INTEGER, y2 AS INTEGER, Dx AS INTEGER, Dy AS INTEGER
'
' 'MouseStatus xt, yt, but
' 'x2 = xt \ BBx: y2 = yt \ BBy           'get starting coordinates for box
'
' DO
'
'    MouseStatus xt, yt, but
'    xt = xt \ BBx
'    yt = yt \ BBy
'    IF xt > BlkWidth - 1 THEN xt = BlkWidth - 1
'    IF yt > BlkHeigth - 1 THEN yt = BlkHeigth - 1
'    IF x2 <> xt OR y2 <> yt THEN
'        x2 = xt
'        y2 = yt
'        'LOCATE 1, 20: PRINT x1; y1; x2; y2
'        DrawCurSprite
'        mousehide
'        IF x2 < x1 THEN Dx = -1 ELSE Dx = 1
'        IF y2 < y1 THEN Dy = -1 ELSE Dy = 1
'        FOR yt = y1 TO y2 STEP Dy
'         FOR xt = x1 TO x2 STEP Dx
'            LINE (xt * BBx + 1, yt * BBy + 1)-STEP(BBx - 2, BBy - 2), CurrentCol, BF
'         NEXT
'        NEXT
'        MouseShow
'    END IF
'
' LOOP UNTIL but <> 1
' 'right mouse button NOT pressed: box selection NOT canceled
' IF but = 0 THEN
'    IF x2 < x1 THEN Dx = -1 ELSE Dx = 1
'    IF y2 < y1 THEN Dy = -1 ELSE Dy = 1
'    FOR yt = y1 TO y2 STEP Dy
'     FOR xt = x1 TO x2 STEP Dx
'        SetCol xt, yt, CurrentCol, FALSE
'     NEXT
'    NEXT
' ELSE
'    SOUND 750, .2
' END IF
'
' DrawCurSprite
' WaitForFreeButton
'
END SUB

DEFINT A-Z
SUB SelectLine (x1, y1, SortOfLine)
DIM temp(0 TO 4097) AS INTEGER
DIM xt, yt, But, x2, y2, xt2, yt2

 MouseStatus x2, y2, But
 x2 = x2 \ BBx: y2 = y2 \ BBy

 IF UseSolids THEN
    mousehide
    PsetSprite 0, 0, Sprites(0, CurSprEdited)
    GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, temp(0)
    SELECT CASE SortOfLine
        CASE 2: LINE (x1, y1)-(x2, y2), CurrentCol
        CASE 3: LINE (x1, y1)-(x2, y2), CurrentCol, B
        CASE 4: LINE (x1, y1)-(x2, y2), CurrentCol, BF
        CASE ELSE: EXIT SUB
    END SELECT
    GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
    MouseShow
    DrawCurSprite
 END IF

 DO
  
    MouseStatus xt, yt, But
    xt = xt \ BBx
    yt = yt \ BBy
    IF xt > BlkWidth - 1 THEN xt = BlkWidth - 1
    IF yt > BlkHeigth - 1 THEN yt = BlkHeigth - 1
    IF xt <> x2 OR yt <> y2 THEN
       mousehide
       IF UseSolids THEN
         x2 = xt: y2 = yt
         PsetSprite 0, 0, temp(0)
         SELECT CASE SortOfLine
            CASE 2: LINE (x1, y1)-(x2, y2), CurrentCol
            CASE 3: LINE (x1, y1)-(x2, y2), CurrentCol, B
            CASE 4: LINE (x1, y1)-(x2, y2), CurrentCol, BF
         END SELECT
         GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
         DrawCurSprite
       ELSE
         'xt = x1: yt = y1: xt2 = x2: yt2 = y2
         'IF x2 < x1 THEN SWAP xt, xt2
         'IF y2 < y1 THEN SWAP yt, yt2
         'IF Grid THEN
         '   LINE (xt * BBx, yt * BBy)-((xt2 + 1) * BBx, (yt2 + 1) * BBy), 8, B, &HAAAA
         'END IF
         DrawGrid
         x2 = xt: y2 = yt
       END IF
       xt = x1: yt = y1: xt2 = x2: yt2 = y2
       IF x2 < x1 THEN SWAP xt, xt2
       IF y2 < y1 THEN SWAP yt, yt2
       LINE (xt * BBx, yt * BBy)-((xt2 + 1) * BBx, (yt2 + 1) * BBy), 15, B, &HAAAA
       MouseShow
    END IF

 LOOP UNTIL But <> 1 OR Scancode% = Esc

 IF (But AND 2) OR Scancode% = Esc THEN   ' Don't paste it !
    mousehide
    PsetSprite 0, 0, temp(0)
    GetSprite 0, 0, BlkWidth - 1, BlkHeigth - 1, Sprites(0, CurSprEdited)
    MouseShow
    SOUND 750, .2
 END IF

 DrawCurSprite
 WaitForFreeButton

END SUB

DEFSNG A-Z
SUB SelectSprite (n AS INTEGER)
  DIM x AS INTEGER, y AS INTEGER, SprOfs&
 
  CurSprEdited = n
  BlkWidth = Sprites(0, CurSprEdited)
  BlkHeigth = Sprites(1, CurSprEdited)
 
  BBx = 6: BBy = 6
  IF BBx * BlkWidth > xMax OR BBy * BlkHeigth > yMax THEN
    BBx = xMax \ BlkWidth
    BBy = yMax \ BlkHeigth
  END IF
  IF BBx < BBy THEN BBy = BBx ELSE BBx = BBy

END SUB

SUB SetCol (x%, y%, c%, DrawIt%)
  DIM SprOfs&

  DEF SEG = VARSEG(Sprites(0, CurSprEdited))
    SprOfs& = VARPTR(Sprites(2, CurSprEdited)) + BlkWidth * y% + x%
    POKE SprOfs&, c%
  DEF SEG
  'LOCATE 2, 15: PRINT Sprites(0, CurSprEdited); Sprites(1, CurSprEdited)

  IF DrawIt% THEN
    mousehide
    FillBar (x% * BBx + Grid), y% * BBy + Grid, BBx - Grid, BBy - Grid, c%
    MouseShow
  END IF

END SUB

DEFINT A-Z
' returns true if the value of the shove was changed, so you can
' make an action if that happens (like changing the palette)
FUNCTION Shove.Check% (sh AS ShoveBarType)
 
  MouseStatus x, y, But
   
  IF But = 1 THEN
   IF sh.sort = 0 THEN  'horizontal shove
    
     IF x > sh.x AND y > sh.y AND x <= sh.x + sh.size AND y < sh.y + 5 THEN
       range = sh.max - sh.min + 1
       tval = sh.max - sh.size * (sh.x + sh.size - x) \ range
       IF tval <> sh.value THEN
         mousehide
         WriteText LTRIM$(STR$(sh.value)), sh.x - 2 + sh.size * sh.value \ range, sh.y + 7, 7
         sh.value = tval
         WriteText LTRIM$(STR$(sh.value)), sh.x - 2 + sh.size * sh.value \ range, sh.y + 7, 0
         LINE (sh.x + 1, sh.y + 1)-STEP(sh.size - 1, 3), 7, BF
         LINE (sh.x + 1, sh.y + 1)-STEP(sh.size * sh.value \ range, 3), sh.Col, BF
         MouseShow
         Shove.Check% = TRUE
         EXIT FUNCTION
       END IF
     END IF
   
    ELSE   'vertical shove
    
     IF x > sh.x AND y > sh.y AND x < sh.x + 6 AND y <= sh.y + sh.size THEN
       range = sh.max - sh.min + 1
       tval = sh.min + sh.size * (sh.y + sh.size - y) \ range
       IF tval <> sh.value THEN
         mousehide
         WriteText LTRIM$(STR$(sh.value)), sh.x + 8, sh.y + sh.size - 2 - sh.size * sh.value \ range, 7
         sh.value = tval
         tval = -sh.size * sh.value \ range
         WriteText LTRIM$(STR$(sh.value)), sh.x + 8, sh.y + sh.size - 2 + tval, 0
         LINE (sh.x + 1, sh.y + 1)-STEP(4, sh.size - 1 + tval), 7, BF
         LINE (sh.x + 1, sh.y + sh.size)-STEP(4, tval), sh.Col, BF
         MouseShow
         Shove.Check% = TRUE
         EXIT FUNCTION
       END IF
     
     END IF
  
   END IF
  END IF
 
  Shove.Check% = 0

END FUNCTION

SUB Shove.Draw (sh AS ShoveBarType)
'x, y, wd, min, max, default, col)
 
  range = sh.max - sh.min + 1
  mousehide
 
  IF sh.sort = 0 THEN  'draw a horizontal shove
    DrawButton sh.x, sh.y, sh.size + 1, 5, 1
    WriteText LTRIM$(STR$(sh.value)), sh.x - 2 + sh.size * sh.value \ range, sh.y + 7, 0
    LINE (sh.x + 1, sh.y + 1)-STEP(sh.size * sh.value \ range, 3), sh.Col, BF
  ELSE
    DrawButton sh.x, sh.y, 6, sh.size + 1, 1
    WriteText LTRIM$(STR$(sh.value)), sh.x + 8, sh.y + sh.size - 2 - sh.size * sh.value \ range, 0
    LINE (sh.x + 1, sh.y + sh.size)-STEP(4, -sh.size * sh.value \ range), sh.Col, BF
  END IF
 
  MouseShow

END SUB

SUB Stretch
  CONST xSpr = 75, ySpr = 45
  DIM mx AS SINGLE, my AS SINGLE, yt AS SINGLE

  WaitForFreeButton
  DrawAll

  mousehide
  DrawButton 70, 30, 129, 124, 0
  DrawButton 71, 31, 127, 9, 1
  WriteText "STRETCH SPRITE", 93, 33, 0
  DrawButton xSpr - 1, ySpr - 1, MaxBlkWidth + 1, MaxBlkHeigth + 1, 1
  PsetSprite xSpr, ySpr, Sprites(0, CurSprEdited)
  WriteText "HEIGHT:", 146, 60, 0
  WriteText "WIDTH:", 150, 85, 0
  WriteText LTRIM$(STR$(BlkHeigth)), 160, 68, 0
  WriteText LTRIM$(STR$(BlkWidth)), 160, 93, 0

  TextButton 86, 137, "  OK  ", 0
  TextButton 140, 137, "CANCEL", 0
  PsetSprite 0, 0, Sprites(0, CurSprEdited)
  MouseShow

  ht = BlkHeigth: wd = BlkWidth

  DO

   'IF Shove.Check%(w) OR Shove.Check%(h) THEN
   'END IF

   MouseStatus x, y, But
   IF But = 1 THEN
    IF y >= ySpr AND y < ySpr + MaxBlkHeigth AND x >= xSpr AND x < xSpr + MaxBlkWidth THEN
     IF y - ySpr + 1 <> ht OR x - xSpr + 1 <> wd THEN
        mousehide
        WriteText LTRIM$(STR$(ht)), 160, 68, 7
        WriteText LTRIM$(STR$(wd)), 160, 93, 7
        ht = y - ySpr + 1: wd = x - xSpr + 1
        WriteText LTRIM$(STR$(ht)), 160, 68, 0
        WriteText LTRIM$(STR$(wd)), 160, 93, 0
        'FillBar xSpr, ySpr, wd, ht, 0
        'PsetSprite xSpr, ySpr, Sprites(0, CurSprEdited)
        'Draw stretched sprite example
        IF wd < MaxBlkWidth THEN LINE (xSpr + wd, ySpr)-(xSpr + MaxBlkWidth - 1, ySpr + MaxBlkHeigth - 1), 7, BF
        IF ht < MaxBlkHeigth THEN LINE (xSpr, ySpr + ht)-(xSpr + MaxBlkWidth - 1, ySpr + MaxBlkHeigth - 1), 7, BF
        mx = wd / BlkWidth: my = ht / BlkHeigth
        imx = CINT(mx): imy = CINT(my)
        FOR y = 0 TO BlkHeigth - 1
         yt = ySpr + y * my
         FOR x = 0 TO BlkWidth - 1
           LINE (xSpr + x * mx, yt)-STEP(imx, imy), Point13%(x, y), BF'GetCol%(CurSprEdited, x, y), BF
         NEXT
        NEXT
        MouseShow
     END IF
    END IF
    IF y < 146 AND y > 137 THEN
      IF x < 128 AND x > 86 THEN      'OK button pressed
         GetSprite xSpr, ySpr, xSpr + wd - 1, ySpr + ht - 1, Sprites(0, CurSprEdited)
         SelectSprite CurSprEdited
         TextButton 86, 137, "  OK  ", 1
         WaitForFreeButton
         EXIT DO
      ELSEIF x > 140 AND x < 182 THEN 'Cancel button pressed
         TextButton 140, 137, "CANCEL", 1
         WaitForFreeButton
         EXIT DO
      END IF
    END IF
   END IF
  LOOP

END SUB

DEFSNG A-Z
SUB Test

mousehide
CLS

FOR y% = 0 TO 199 - BlkHeigth STEP (BlkHeigth * 2)
FOR x% = 0 TO 319 - BlkWidth STEP (BlkWidth * 2)
    FillBar x%, y%, BlkWidth, BlkHeigth, (x% \ BlkHeigth + y%) MOD 255
    PutSprite x%, y%, Sprites(0, CurSprEdited)
NEXT x%
NEXT y%


DO: MouseStatus x%, y%, But%
LOOP UNTIL INKEY$ <> "" OR But% <> 0

WaitForFreeButton


MouseShow
DrawAll

END SUB

SUB WaitForFreeButton
   
    DO: MouseStatus x%, y%, But%
    LOOP UNTIL But% = 0

END SUB

SUB WaitForPressedButton
   
    DO: MouseStatus x%, y%, But%
    LOOP UNTIL But% <> 0

END SUB

